// cards.js

function place_agents_cards()
{
  let agents_cards = world.getAllObjects().filter(object=>object.getTemplateName()=="agents_cards");
  let assassin = agents_cards.find(card=>card.getCardDetails().name=="Assassin");
  let double_agent = agents_cards.find(card=>card.getCardDetails().name=="Double Agent");
  let civilians = agents_cards.filter(card=>card.getCardDetails().name=="Civilian");
  let red_agents = agents_cards.filter(card=>card.getCardDetails().name=="Red Agent");
  let blue_agents = agents_cards.filter(card=>card.getCardDetails().name=="Blue Agent");

  let x0 = -36.0; let y0 = 0; let z = 88;
  let dx = 6; let dy = 8;
  let assassin_position = new Vector(x0, y0, z);
  let double_position = new Vector(x0+dx, y0, z);

  let civilians_positions =
  [ new Vector(x0+dx, y0-dy, z),                              new Vector(x0+dx, y0+dy, z),
    new Vector(x0   , y0-dy, z),                              new Vector(x0   , y0+dy, z),
    new Vector(x0-dx, y0-dy, z), new Vector(x0-dx, y0   , z), new Vector(x0-dx, y0+dy, z),
  ];

  let yr = -18;
  let red_agents_positions =
  [ new Vector(x0+dx, yr-2*dy, z), new Vector(x0+dx, yr-1*dy, z), new Vector(x0+dx, yr-0*dy, z),
    new Vector(x0   , yr-2*dy, z), new Vector(x0   , yr-1*dy, z), new Vector(x0   , yr-0*dy, z),
                                   new Vector(x0-dx, yr-1*dy, z), new Vector(x0-dx, yr-0*dy, z),
  ];

  let yb = -yr;
  let blue_agents_positions =
  [ new Vector(x0+dx, yb+0*dy, z), new Vector(x0+dx, yb+1*dy, z), new Vector(x0+dx, yb+2*dy, z),
    new Vector(x0   , yb+0*dy, z), new Vector(x0   , yb+1*dy, z), new Vector(x0   , yb+2*dy, z),
    new Vector(x0-dx, yb+0*dy, z), new Vector(x0-dx, yb+1*dy, z),
  ];

  let rot = new Rotator(0,0,0);
  assassin.setPosition(assassin_position); assassin.setRotation(rot);
  double_agent.setPosition(double_position); double_agent.setRotation(rot);
  for(let i=0; i<7; i++) { civilians[i].setPosition(civilians_positions[i]); civilians[i].setRotation(rot); }
  for(let i=0; i<8; i++) { red_agents[i].setPosition(red_agents_positions[i]); red_agents[i].setRotation(rot); }
  for(let i=0; i<8; i++) { blue_agents[i].setPosition(blue_agents_positions[i]); blue_agents[i].setRotation(rot); }

}

module.exports = { place_agents_cards };
