// game.js

let { pull_cards } = require('./cards.js');

let { place_agents_cards } = require('./agents.js');
let { place_words_cards, clear_words_cards } = require('./words.js');
let deckmat = world.getObjectById('yjg');
let discardmat = world.getObjectById('4jf');
let keycards = world.getObjectById('2cs');

function deal()
{
  let decksnap = deckmat.getSnapPoint(0);
  let deck = decksnap.getSnappedObject();
  let discard = discardmat.getSnapPoint(0).getSnappedObject();
  if(!deck && !discard)
  { world.broadcastChatMessage("Please place a deck on the deck mat.", new Color(1, 1/4, 1/4)); return;
  }
  else if(!deck && discard)
  { deck = discard.takeCards(discard.getStackSize());
    deck.setPosition(deckmat.getPosition().add(new Vector(0,0,1)));
    deck.snap();
    deck.shuffle();
  }
  else if(deck.getStackSize()<25)
  { deck.addCards(discard);
    deck.shuffle();
  }
  else
  { deck.shuffle();
  }
  place_words_cards(pull_cards(25, deck));
}

function clear()
{ let discard = discardmat.getSnapPoint(0).getSnappedObject();
  clear_words_cards(discard);
  let keycard = world.sphereOverlap(new Vector(-54, 0, 87), 1)[0];
  if(keycard) { keycards.addCards(keycard);}
}

let red_clues = world.getObjectById('rpb');
let blue_clues = world.getObjectById('iqc');

function new_keycard()
{ keycards.shuffle();
  let keycard = keycards.takeCards(1);
  keycard.setPosition(new Vector(-54, 0, 88));
  keycard.setRotation(new Rotator(0, 0, 0));
}

function new_game()
{
  place_agents_cards();
  clear();
  deal();
  red_clues.reset_clues();
  blue_clues.reset_clues();
  new_keycard();
}




function place_newgame_button()
{
  let text = "New Game";
  let button = new Button().setText(text);
  button.onClicked.add(new_game); // (button, player)=>{}
  let ui = new UIElement();
  ui.position = new Vector(66, 0, 88);
  ui.widget = button;
  ui.scale = 1.5;
  world.addUI(ui);
}

function place_peek_hint()
{ let text = new Text().setText("Spymasters peek here");
  let ui = new UIElement();
  ui.position = new Vector(-58, 0, 87);
  ui.widget = text;
  ui.scale = 0.6;
  world.addUI(ui);
}

place_newgame_button();
place_peek_hint();
